#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-

## @Library Source Path.
# To Be Editted by User.
#
# @Source Path.
# To Be Editted by User.
# IPAddress of the PC which Visual Sense RTCs exit in.
# To Be Editted by User.

import sys
import time
import math
sys.path.append("../../etc")
from set_env import *
sys.path.append(LibDir)
from rtc_handle import *
sys.path.append(SrcDir+'/tools/geo')
from geo import *
sys.path.append(BinDir+"/comp")
import _GlobalIDL


##
# model data  name:ID
model_data = { "can":1,
               "petfruit":2,
               "biscuit":5,
               "holder":15 }
##
# 
def assign_variables(env) :
  global multicam, multidisp, measure, viewer, recognition, coordtrans
  multicam  = env.name_space[DRINK_NS].rtc_handles['MultiCamera0.rtc']
  multidisp  = env.name_space[DRINK_NS].rtc_handles['MultiDisp0.rtc']
  measure    = env.name_space[DRINK_NS].rtc_handles['Measure3D0.rtc']
  viewer     = env.name_space[DRINK_NS].rtc_handles['RecognitionResultViewer0.rtc']  
  recognition  = env.name_space[DRINK_NS].rtc_handles['Recognition0.rtc']
  coordtrans  = env.name_space[DRINK_NS].rtc_handles['CoordTrans0.rtc']
  recognition.services['Recognition'].provided['recogPort'].narrow_ref(globals())

##
#
def activate() :
  multicam.activate()
  multidisp.activate()
  measure.activate()
  viewer.activate()
  coordtrans.activate()
  recognition.activate()
##
#
def deactivate() :
  multicam.deactivate()
  multidisp.deactivate()
  measure.deactivate()
  viewer.deactivate()
  coordtrans.deactivate()
  recognition.deactivate()
##
#
def end(env) :
  deactivate()
  #disconnect_all(env)

##
#  start recognition
def start_recog(model_id) :
  recognition.services['Recognition'].provided['recogPort'].ref.setModelID(model_id)

##
#  look at an object which is specified by idx
def lookat(model) :
  global model_data, data
  coordtrans.outports['Transformed'].open()
  trial = 0
  lim = 10
  while trial < lim :
    trial += 1
    print" trial: %d" % trial
    start_recog(model_data[model])
    print"  On Analyzing.."
    # 計測所用時間スリープ（実測値は0.3～0.5秒）
    time.sleep(4)
    # get recognition data
    try:
      data = coordtrans.outports['Transformed'].read().data
      print"read successfuly."
    except AttributeError:
      continue

    if(chk_drink(data) == 0) :
      print"  Found objects!"
      print"  TARGET",
      print" X %.1fcm" % data[11],
      print" Y %.1fcm" % data[15],
      print" Z %.1fcm" % data[19]
      print"          X_axis %.2f %.2f %.2f" % (data[8],  data[12],  data[16])
      print"          Y_axis %.2f %.2f %.2f" % (data[9], data[13], data[17])
      print"          Z_axis %.2f %.2f %.2f" % (data[10], data[14], data[18])
      coordtrans.outports['Transformed'].close()
      return 0
  if(trial == lim) :
    print("  Found Nothing..")
  coordtrans.outports['Transformed'].close()
  return 1

##
# check a target(= drink on table)
#   check item: reliability >= 0.30: OK, otherwise NG
#               345[mm] <= height <= 365[mm]: OK, otherwise NG
#               distance from PA10
#               drinks on a table must locate apart from 400[mm] to 900[mm]
def chk_drink(data) :
  # check reliability
  min_rel = 0.30
  if(data[4] < min_rel) :
    print" reliability = %.4f" % data[4]
    return 1
  # check height
  drink_height = 355
  if(data[19] < drink_height - 10 or data[19] > drink_height + 10) :
    return 1
  # check distance from PA10
  radius = math.sqrt(data[11] * data[11] + data[15] * data[15])
  if(radius < 400 or radius > 900) :
    return 1
  # may be right target 
  return 0
##
#
def disconnect_all(env) :
  for con in env.con_list :
    con.disconnect()
def connect_list(env,ll) :
  for i in ll :
    env.con_list[i].connect()
def disconnect_list(env,ll) :
  for i in ll :
    env.con_list[i].disconnect()

##
# start handle
def start_handle(env) :
  assign_variables(env)
  #make_connectors(env)
  #connect_list(env,[0,1,2,3,4])
  activate()


###############################
#  start a demonstration      #
###############################
env = RtmEnv(sys.argv,[ DRINK_NS ])
for ns in env.name_space :
  env.name_space[ns].list_obj()
start_handle(env)

