#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-

## @Library Source Path.
# To Be Editted by User.
#
# @Source Path.
# To Be Editted by User.
# IPAddress of the PC which Visual Sense RTCs exit in.
# To Be Editted by User.

import sys
import time
import math
sys.path.append("../../etc")
from set_env import *
sys.path.append(LibDir)
from rtc_handle import *
sys.path.append(SrcDir+'/tools/geo')
from geo import *
sys.path.append(BinDir+"/comp")
import _GlobalIDL


##
# 
def assign_variables(env) :
  global multicam, multidisp, measure, viewer, recognition, coordtrans
  multicam  = env.name_space[DRINK_NS].rtc_handles['MultiCamera0.rtc']
  multidisp  = env.name_space[DRINK_NS].rtc_handles['MultiDisp0.rtc']
  measure    = env.name_space[DRINK_NS].rtc_handles['Measure3D0.rtc']
  viewer     = env.name_space[DRINK_NS].rtc_handles['RecognitionResultViewer0.rtc']  
  recognition  = env.name_space[DRINK_NS].rtc_handles['Recognition0.rtc']
  coordtrans  = env.name_space[DRINK_NS].rtc_handles['CoordTrans0.rtc']
  recognition.services['Recognition'].provided['recogPort'].narrow_ref(globals())
  
##
#
def make_connectors(env):
  env.con_list=[]
# 0
  con = IOConnector([multicam.outports['images'],multidisp.inports['images']])
  env.con_list.append(con)
# 1
  con = IOConnector([multicam.outports['images'],measure.inports['ImageIn']])
  env.con_list.append(con)
# 2
  con = IOConnector([measure.outports['Data3DOut'],recognition.inports['Stereo3DIn']])
  env.con_list.append(con)
# 3
  con = IOConnector([recognition.outports['RecognitionResultOut'],coordtrans.inports['RecogResult']])
  env.con_list.append(con)
# 4
  con = ServiceConnector([multicam.services['control'],measure.services['CameraCapture']])
  env.con_list.append(con)
# 5
  con = ServiceConnector([measure.services['Reconstruct3D'],recognition.services['Reconstruct3D']])
  env.con_list.append(con)
# 6
  con = ServiceConnector([recognition.services['RecognitionResultViewer'],viewer.services['RecognitionResultViewer']])
  env.con_list.append(con)
  
##
#
##
#
def disconnect_all(env) :
  for con in env.con_list :
    con.disconnect()
def connect_list(env,ll) :
  for i in ll :
    env.con_list[i].connect()
def disconnect_list(env,ll) :
  for i in ll :
    env.con_list[i].disconnect()

##
# start handle
def start_handle(env) :
  assign_variables(env)
  make_connectors(env)
  connect_list(env,[0,1,2,3,4,5,6])
  #coordtrans.outports['Transformed'].open()
  #activate()


###############################
#  start a demonstration      #
###############################
env = RtmEnv(sys.argv,[ DRINK_NS ])
for ns in env.name_space :
  env.name_space[ns].list_obj()
start_handle(env)

