// -*-C++-*-
/*!
 * @file  PA10SystemControllerSVC_impl.cpp
 * @brief Service implementation code of PA10SystemController.idl
 *
 */

#include "PA10SystemControllerSVC_impl.h"

/*
 * Example implementational code for IDL interface PA10SystemControl
 */
PA10SystemControlSVC_impl::PA10SystemControlSVC_impl()
:rtclog("PA10SystemControlSVC_impl")
{
  // Please add extra constructor code here.
}


PA10SystemControlSVC_impl::~PA10SystemControlSVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
CORBA::Long PA10SystemControlSVC_impl::PA10GetStatus()
{
  /*
   * PA10システムの状態を取得
   * 0:待機中
   * 1:起動中
   * 2:給仕中
   * 3:終了
   * 4:給仕完了
   */
  return PA10state;
}

void PA10SystemControlSVC_impl::PA10SetStatus(CORBA::Long state)
{

  //PA10の状態をセット
  PA10state = state;
  std::cout << "PA10 state changed : " << &PA10state_list[PA10state][0] << std::endl;
  RTC_INFO(("PA10 state changed : %s",&PA10state_list[PA10state][0]));

}

void PA10SystemControlSVC_impl::PA10End()
{
  //RTCの終了
  char cmd[128];
  sprintf( cmd, "cd ~/PCforSystemControl/bin/script; python exitPA10.py");
  system(cmd);
  
}

void PA10SystemControlSVC_impl::PA10DrinkServeReq(CORBA::Short drinknum)
{

  if(PA10state == 0){
  
  	//状態変更（待機　→　給仕中）
  	PA10SetStatus(2);
  	  	
  	//給仕作業開始（ワーカスレッドの起動）
  	args[0] = (char)drinknum;
  	strcpy(&args[1], scenario_script);
  	if(pthread_create(&threadid, NULL, thread_main, args)){
  		std::cout << "pthread_create error!" << std::endl;
  		RTC_ERROR(("pthread_joint error!"));
  	}
  }else {
  	//給仕不可能な状態
  	std::cout << "現在給仕作業を受け付けることができません!" << PA10state << std::endl;
  	std::cout << "PA10 STATUS" << std::endl;
  	std::cout << " 0:待機中" << std::endl;
  	std::cout << " 1:起動中" << std::endl;
  	std::cout << " 2:給仕中" << std::endl;
  	std::cout << " 3:終了" << std::endl;
  	std::cout << " 4:給仕完了" << std::endl;
  }
}
/*
 * PA10のエラーをセット
 * 0:異常なし。
 * 1:システム内RTCが全て起動していません。
 * 2:給仕シナリオ実行スレッド終了に失敗しました。
 * 3:PA10の状態が未定義の状態です。
 * 4:実機エラーが発生しました。
 */
void PA10SystemControlSVC_impl::PA10ReportError(CORBA::Long errnum)
{
  	PA10err = errnum;
  	RTC_ERROR(("ErrorReport: %d, %s",errnum, &PA10err_list[errnum][0]));
}

/* 
 * 給仕スクリプトを実行する
 * 引数：給仕するドリンク数
 */
void* thread_main(void* args){

  char cmd[128];
  char* str = (char* )(args);
  
  //給仕シナリオスクリプト実行
  sprintf( cmd, &str[1], (short)str[0]);
  system(cmd);

}

// End of example implementational code



