#!/usr/bin/env python
# -*- Python -*-

"""
 \file pa10disp.py
 \brief visual model of PA10
 \date $Date$


"""
import sys
import time
sys.path.append(".")
save_path = sys.path[:]

# Import RTM module
import OpenRTM_aist
import RTC

# MyRtcDir=".."
sys.path.append("../../etc")
from set_env import *
sys.path.append(SrcDir+'/tools/v_robot')
from v_pa10 import *
sys.path = save_path


# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
pa10disp_spec = ["implementation_id", "pa10disp", 
		 "type_name",         "pa10disp", 
		 "description",       "visual model of PA10", 
		 "version",           "1.0.0", 
		 "vendor",            "suehiro", 
		 "category",          "7dof_arm_cg", 
		 "activity_type",     "STATIC", 
		 "max_instance",      "1", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
#		 "exec_cxt.periodic.rate", "500.0",
		 ""]
# </rtc-template>
class DrawPa10(OpenRTM_aist.ConnectorDataListenerT) :
    def __init__(self, comp) :
        print "DrawPa10"
        self._name="draw_pa10"
        self.comp=comp
    def __call__(self, info, cdrdata):
      value = OpenRTM_aist.ConnectorDataListenerT.__call__(self, info, cdrdata, RTC.TimedDoubleSeq(RTC.Time(0,0),[]))
      if(self.comp.act_flag) :
          th=value.data
          link1.set_joint(th[0])
          link2.set_joint(th[1])
          link3.set_joint(th[2])
          link4.set_joint(th[3])
          link5.set_joint(th[4])
          link6.set_joint(th[5])
          link7.set_joint(th[6])

class pa10disp(OpenRTM_aist.DataFlowComponentBase):
	
	"""
	\class pa10disp
	\brief visual model of PA10
	
	"""
	def __init__(self, manager):
		"""
		\brief constructor
		\param manager Maneger Object
		"""
		OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

		self._d_th = RTC.TimedDoubleSeq(RTC.Time(0,0),[])
		"""
		"""
		self._thIn = OpenRTM_aist.InPort("th", self._d_th)
#		print "create callback"
		self.draw_pa10=DrawPa10(self)
#                print "adding callback"
		self._thIn.addConnectorDataListener(OpenRTM_aist.ConnectorDataListenerType.ON_BUFFER_WRITE, self.draw_pa10)
#		self._thIn.addConnectorDataListener(OpenRTM_aist.ConnectorDataListenerType.ON_RECEIVED, self.draw_pa10)
#		print "set callback"
		# initialize of configuration-data.
		# <rtc-template block="init_conf_param">
		
		# </rtc-template>


		 
	def onInitialize(self):
		"""
		
		The initialize action (on CREATED->ALIVE transition)
		formaer rtc_init_entry() 
		
		\return RTC::ReturnCode_t
		
		"""
		# Bind variables and configuration variable
		
		# Set InPort buffers
		self.registerInPort("th",self._thIn)
		
		# Set OutPort buffers
		
		# Set service provider to Ports
		
		# Set service consumers to Ports
		
		# Set CORBA Service Ports
		visual.rate(10.0)
		self.act_flag=False
		return RTC.RTC_OK
	
	def onFinalize(self, ec_id):
		"""
	
		The finalize action (on ALIVE->END transition)
		formaer rtc_exiting_entry()
	
		\return RTC::ReturnCode_t
	
		"""
		self.act_flag=False
		return RTC.RTC_OK
	
	#def onStartup(self, ec_id):
	#	"""
	#
	#	The startup action when ExecutionContext startup
	#	former rtc_starting_entry()
	#
	#	\param ec_id target ExecutionContext Id
	#
	#	\return RTC::ReturnCode_t
	#
	#	"""
	#
	#	return RTC.RTC_OK
	
	#def onShutdown(self, ec_id):
	#	"""
	#
	#	The shutdown action when ExecutionContext stop
	#	former rtc_stopping_entry()
	#
	#	\param ec_id target ExecutionContext Id
	#
	#	\return RTC::ReturnCode_t
	#
	#	"""
	#
	#	return RTC.RTC_OK
	
	def onActivated(self, ec_id):
		"""

		The activated action (Active state entry action)
		former rtc_active_entry()
	
		\param ec_id target ExecutionContext Id
	
		\return RTC::ReturnCode_t
	
		"""
		self.act_flag=True
		return RTC.RTC_OK
	
	def onDeactivated(self, ec_id):
		"""
	
		The deactivated action (Active state exit action)
		former rtc_active_exit()
	
		\param ec_id target ExecutionContext Id
	
		\return RTC::ReturnCode_t
	
		"""
		self.act_flag=False
		return RTC.RTC_OK
	
#	def onExecute(self, ec_id):
#		if self._thIn.isNew() :
#			th=self._thIn.read().data
#			link1.set_joint(th[0])
#			link2.set_joint(th[1])
#			link3.set_joint(th[2])
#			link4.set_joint(th[3])
#			link5.set_joint(th[4])
#			link6.set_joint(th[5])
#			link7.set_joint(th[6])	
#		return RTC.RTC_OK
	
	def onAborting(self, ec_id):
		"""
	
		The aborting action when main logic error occurred.
		former rtc_aborting_entry()
	
		\param ec_id target ExecutionContext Id
	
		\return RTC::ReturnCode_t
	
		"""
		self.act_flag=False	
		return RTC.RTC_OK
	
	def onError(self, ec_id):
		"""
	
		The error action in ERROR state
		former rtc_error_do()
	
		\param ec_id target ExecutionContext Id
	
		\return RTC::ReturnCode_t
	
		"""
		self.act_flag=False	
		return RTC.RTC_OK
	
	def onReset(self, ec_id):
		"""
	
		The reset action that is invoked resetting
		This is same but different the former rtc_init_entry()
	
		\param ec_id target ExecutionContext Id
	
		\return RTC::ReturnCode_t
	
		"""
		self.act_flag=False	
		return RTC.RTC_OK
	
	#def onStateUpdate(self, ec_id):
	#	"""
	#
	#	The state update action that is invoked after onExecute() action
	#	no corresponding operation exists in OpenRTm-aist-0.2.0
	#
	#	\param ec_id target ExecutionContext Id
	#
	#	\return RTC::ReturnCode_t
	#
	#	"""
	#
	#	return RTC.RTC_OK
	
	#def onRateChanged(self, ec_id):
	#	"""
	#
	#	The action that is invoked when execution context's rate is changed
	#	no corresponding operation exists in OpenRTm-aist-0.2.0
	#
	#	\param ec_id target ExecutionContext Id
	#
	#	\return RTC::ReturnCode_t
	#
	#	"""
	#
	#	return RTC.RTC_OK
	



def MyModuleInit(manager):
    profile = OpenRTM_aist.Properties(defaults_str=pa10disp_spec)
    manager.registerFactory(profile,
                            pa10disp,
                            OpenRTM_aist.Delete)

    # Create a component
    comp = manager.createComponent("pa10disp")



def main():
	mgr = OpenRTM_aist.Manager.init(sys.argv)
	mgr.setModuleInitProc(MyModuleInit)
	mgr.activateManager()
	mgr.runManager()

if __name__ == "__main__":
	main()

