#!/usr/bin/env python
# -*- Python -*-



import sys
import time
sys.path.append(".")
save_path = sys.path[:]

# Import RTM module
import OpenRTM_aist
import RTC

sys.path.append("../../etc")
from set_env import *
sys.path.append(SrcDir+'/tools/v_robot')
from v_pa10 import *
sys.path = save_path

# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="global_idl">

# </rtc-template>

class DrawPa10(OpenRTM_aist.ConnectorDataListenerT) :
    def __init__(self, comp) :
        self.comp=comp
    def __call__(self, info, cdrdata):
        value = OpenRTM_aist.ConnectorDataListenerT.__call__(self, info, cdrdata, RTC.TimedDoubleSeq(RTC.Time(0,0),[]))
        if(self.comp.act_flag) :
            th=value.data
            link1.set_joint(th[0])
            link2.set_joint(th[1])
            link3.set_joint(th[2])
            link4.set_joint(th[3])
            link5.set_joint(th[4])
            link6.set_joint(th[5])
            link7.set_joint(th[6])

class DrawPa10hand(OpenRTM_aist.ConnectorDataListenerT) :
    def __init__(self, comp) :
        self.comp=comp
    def __call__(self, info, cdrdata):
        value = OpenRTM_aist.ConnectorDataListenerT.__call__(self, info, cdrdata, RTC.TimedDouble(RTC.Time(0,0),0.0))
        if(self.comp.act_flag) :
            width=value.data
	    hand.set_joint(width)

# This module's spesification
# <rtc-template block="module_spec">
pa10disp_spec = ["implementation_id", "pa10disp", 
		 "type_name",         "pa10disp", 
		 "description",       "visual model of PA10", 
		 "version",           "1.0", 
		 "vendor",            "Takashi Suehiro, AIST", 
		 "category",          "7dof_arm", 
		 "activity_type",     "DataFlowComponent", 
		 "max_instance",      "10", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
#		 "exec_cxt.periodic.rate", "500.0",
		 ""]

hand_disp_spec = ["implementation_id", "hand_disp", 
		 "type_name",         "hand_disp", 
		 "description",       "visual model of hand", 
		 "version",           "1.0", 
		 "vendor",            "Takashi Suehiro, AIST", 
		 "category",          "hand", 
		 "activity_type",     "DataFlowComponent", 
		 "max_instance",      "10", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 "exec_cxt.periodic.rate", "500.0",
		 ""]

# </rtc-template>

class pa10disp(OpenRTM_aist.DataFlowComponentBase):
	def __init__(self, manager):
		OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

		# DataPorts initialization
		# <rtc-template block="data_ports">
		self._d_th = RTC.TimedDoubleSeq(RTC.Time(0,0),[])
		self._thIn = OpenRTM_aist.InPort("th", self._d_th)

		# </rtc-template>
		self.draw_pa10=DrawPa10(self)
		self._thIn.addConnectorDataListener(OpenRTM_aist.ConnectorDataListenerType.ON_BUFFER_WRITE, self.draw_pa10)
		# DataPorts initialization
		# <rtc-template block="service_ports">

		# </rtc-template>


		# initialize of configuration-data.
		# <rtc-template block="configurations">

		# </rtc-template>

		 
	def onInitialize(self):
		# Bind variables and configuration variable
		# <rtc-template block="bind_config">
		# </rtc-template>
		self.registerInPort("th",self._thIn)
                visual.rate(10)
		self.act_flag = False
		return RTC.RTC_OK


	#def onFinalize(self):
	#	return RTC.RTC_OK

	#def onStartup(self, ec_id):
	#	return RTC.RTC_OK

	#def onShutdown(self, ec_id):
	#	return RTC.RTC_OK

        def onActivated(self, ec_id):
            self.act_flag = True
            return RTC.RTC_OK

	def onDeactivated(self, ec_id):
            self.act_flag = False
	    return RTC.RTC_OK

#	def onExecute(self, ec_id):
#
#            if self._thIn.isNew() :
#                th=self._thIn.read().data
#                link1.set_joint(th[0])
#                link2.set_joint(th[1])
#                link3.set_joint(th[2])
#                link4.set_joint(th[3])
#                link5.set_joint(th[4])
#                link6.set_joint(th[5])
#                link7.set_joint(th[6])
#            time.sleep(0.01)
#            return RTC.RTC_OK

	def onAborting(self, ec_id):
            self.act_flag = False
	    return RTC.RTC_OK

	def onError(self, ec_id):
            self.act_flag = False
	    return RTC.RTC_OK

	def onReset(self, ec_id):
            self.act_flag = False
	    return RTC.RTC_OK

	#def onStateUpdate(self, ec_id):
	#	return RTC.RTC_OK

	#def onRateChanged(self, ec_id):
	#	return RTC.RTC_OK


class hand_disp(OpenRTM_aist.DataFlowComponentBase):
	def __init__(self, manager):
		OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

		# DataPorts initialization
		# <rtc-template block="data_ports">
		self._d_width = RTC.TimedDouble(RTC.Time(0,0),0)
		self._widthIn = OpenRTM_aist.InPort("width", self._d_width)
		# </rtc-template>
                self.d_hand=DrawPa10hand(self)
		self._widthIn.addConnectorDataListener(OpenRTM_aist.ConnectorDataListenerType.ON_BUFFER_WRITE, self.d_hand)

		# DataPorts initialization
		# <rtc-template block="service_ports">

		# </rtc-template>


		# initialize of configuration-data.
		# <rtc-template block="configurations">

		# </rtc-template>

		 
	def onInitialize(self):
		# Bind variables and configuration variable
		# <rtc-template block="bind_config">


		# </rtc-template>
		self.registerInPort("width",self._widthIn)
                visual.rate(10)
                self.act_flag = False
		return RTC.RTC_OK


	#def onFinalize(self):
	#	return RTC.RTC_OK

	#def onStartup(self, ec_id):
	#	return RTC.RTC_OK

	#def onShutdown(self, ec_id):
	#	return RTC.RTC_OK

	def onActivated(self, ec_id):
            self.act_flag = True
            return RTC.RTC_OK

	def onDeactivated(self, ec_id):
            self.act_flag = False
	    return RTC.RTC_OK

#	def onExecute(self, ec_id):
#            if self._widthIn.isNew() :
#                width=self._widthIn.read().data
#                hand.set_joint(width)
#            return RTC.RTC_OK

	def onAborting(self, ec_id):
            self.act_flag = False
	    return RTC.RTC_OK

	def onError(self, ec_id):
            self.act_flag = False
	    return RTC.RTC_OK

	def onReset(self, ec_id):
            self.act_flag = False
	    return RTC.RTC_OK

	#def onStateUpdate(self, ec_id):
	#	return RTC.RTC_OK

	#def onRateChanged(self, ec_id):
	#	return RTC.RTC_OK



def MyModuleInit(manager):
    print "aho 1.1"
    profile = OpenRTM_aist.Properties(defaults_str=pa10disp_spec)
    print "aho 1.2"
    manager.registerFactory(profile,
                            pa10disp,
                            OpenRTM_aist.Delete)

    # Create a component
    print "aho 1.3"
    comp1 = manager.createComponent("pa10disp")
    print "aho 1.4"

    profile = OpenRTM_aist.Properties(defaults_str=hand_disp_spec)
    print "aho 1.5"
    manager.registerFactory(profile,
                            hand_disp,
                            OpenRTM_aist.Delete)
    print "aho 1.6"

    # Create a component
    comp2 = manager.createComponent("hand_disp")
    print "aho 1.7"



def main():
	print "aho 1"
	mgr = OpenRTM_aist.Manager.init(sys.argv)
	print "aho 2"
	mgr.setModuleInitProc(MyModuleInit)
	print "aho 3"
	mgr.activateManager()
	print "aho 4"
	mgr.runManager()

if __name__ == "__main__":
	main()


